(defun c:DH 
	;author hak_vz  
	;https://forums.autodesk.com/t5/user/viewprofilepage/user-id/5530556
	;Thursday, September 2, 2021
	(
	/ *error* take pointlist3d sset->enameList get_intersections get_intersection_points
	adoc ss enameList pt line_hor line_hor_obj line_ver line_ver_obj i pl pr pu pb eo int_pts
	)
	(defun *error* ( msg )
		(if (not (member msg '("Function cancelled" "quit / exit abort")))
			(princ)
		)
		(setvar 'cmdecho 1)
		(princ)
	)
	(defun take (amount lst / ret)(repeat amount (setq ret (cons (car lst) (take (1- amount) (cdr lst))))))
	(defun pointlist3d (lst / ret) (while lst (setq	ret (cons (take 3 lst) ret) lst (cdddr lst))) (reverse ret))
	(defun sset->enameList (ss / i ret)
		; extracts elements name for all objects in a selection set into a list
		(if ss
			(repeat (setq i (sslength ss))
				(setq ret (cons (ssname ss (setq i (1- i))) ret))
			) ;_ end of repeat
		) ;_ end of if
	) ;_ end of defun
	(defun get_intersections	(obj1 obj2 / var)
		(setq var (vlax-variant-value (vla-intersectwith obj1 obj2 1)))
		(if (< 0 (vlax-safearray-get-u-bound var 1))(vlax-safearray->list var))
	)
	(defun get_intersection_points (obj1 obj2) (pointlist3d (get_intersections obj1 obj2)))
	(setvar 'cmdecho 0)
	(setq ss (ssget "_X" '((0 . "LWPOLYLINE,LINE,CIRCLE,ELLIPSE"))))
	(setq enameList (sset->enameList ss))
	(while (setq pt (getpoint "\nPick a point"))
		(setq line_ver
			(entmakex
				(list
					(cons 0 "XLINE")
					(cons 100 "AcDbEntity")
					(cons 100 "AcDbXline")
					(cons 10 (trans pt 1 0))
					(cons 11 '(0 1 0))
				)
			)
		)
		(setq line_ver_obj (vlax-ename->vla-object line_ver))
		(setq line_hor
			(entmakex
				(list
					(cons 0 "XLINE")
					(cons 100 "AcDbEntity")
					(cons 100 "AcDbXline")
					(cons 10 (trans pt 1 0))
					(cons 11 '(1 0 0))
				)
			)
		)
		(setq line_hor_obj (vlax-ename->vla-object line_hor))
		
		(setq i -1 pl nil pr nil)
		(while (< (setq i (1+ i)) (length enameList))
			(setq eo (vlax-ename->vla-object (nth i enameList)))
			(setq int_pts (get_intersection_points line_hor_obj eo))
			(foreach ipt int_pts
				(cond 
					((and (not pl)(< (car ipt) (car pt)))
						(setq pl ipt)
					)
					((and (not pr)(> (car ipt) (car pt)))
						(setq pr ipt)
					)
					(
						(and 
							(and pl)
							(< (car ipt) (car pt))
							(< (distance ipt pt)(distance pl pt))
						)
						(setq pl ipt)
					)
					(
						(and 
							(and pr)
							(> (car ipt) (car pt))
							(< (distance ipt pt)(distance pr pt))
						)
						(setq pr ipt)
					)
				)
			)
			(setq int_pts nil)
		)
		(cond 
			((and pl pr)
				(command "_.dimhorizontal" pl pr pr)
			)
		)
		(setq pl nil pr nil)
		;-----------
		(setq i -1 pu nil pb nil)
		(while (< (setq i (1+ i)) (length enameList))
			(setq eo (vlax-ename->vla-object (nth i enameList)))
			(setq int_pts (get_intersection_points line_ver_obj eo))
			(foreach ipt int_pts
				(cond 
					((and (not pb)(< (cadr ipt) (cadr pt)))
						(setq pb ipt)
					)
					((and (not pu)(> (cadr ipt) (cadr pt)))
						(setq pu ipt)
					)
					(
						(and 
							(and pb)
							(< (cadr ipt) (cadr pt))
							(< (distance ipt pt)(distance pb pt))
						)
						(setq pb ipt)
					)
					(
						(and 
							(and pu)
							(> (cadr ipt) (cadr pt))
							(< (distance ipt pt)(distance pu pt))
						)
						(setq pu ipt)
					)
				)
			)
			(setq int_pts nil)
		)
		(cond 
			((and pb pu)
				(command "_.dimvertical" pb pu pu)
			)
		)
		(setq pu nil pb nil)
		(vlax-release-object line_hor_obj)
		(vlax-release-object line_ver_obj)	
	    (entdel line_hor)
		(entdel line_ver)
	)
	(setvar 'cmdecho 1)
(princ)
)